"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _events = _interopRequireDefault(require("events"));

var _assert = _interopRequireDefault(require("assert"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

var SERVICE_UUID = '0000aadb-0000-1000-8000-00805f9b34fb';
var CHARACTERISTIC_UUID = '0000aadc-0000-1000-8000-00805f9b34fb';
var faces = ['B', 'D', 'L', 'U', 'R', 'F'];
var turns = [1, 2, -1];

var Giiker =
/*#__PURE__*/
function (_EventEmitter) {
  _inherits(Giiker, _EventEmitter);

  function Giiker() {
    var _this;

    _classCallCheck(this, Giiker);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Giiker).call(this));
    _this.onCharacteristicValueChanged = _this.onCharacteristicValueChanged.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    return _this;
  }

  _createClass(Giiker, [{
    key: "connect",
    value: function () {
      var _connect = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var device, server, service, characteristic, initialValue;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (global.navigator) {
                  _context.next = 2;
                  break;
                }

                throw new Error('window.navigator is not accesible. Maybe you\'re running Node.js?');

              case 2:
                if (global.navigator.bluetooth) {
                  _context.next = 4;
                  break;
                }

                throw new Error('Web Bluetooth API is not accesible');

              case 4:
                _context.next = 6;
                return global.navigator.bluetooth.requestDevice({
                  filters: [{
                    namePrefix: 'GiC'
                  }],
                  optionalServices: [SERVICE_UUID]
                });

              case 6:
                device = _context.sent;
                _context.next = 9;
                return device.gatt.connect();

              case 9:
                server = _context.sent;
                _context.next = 12;
                return server.getPrimaryService(SERVICE_UUID);

              case 12:
                service = _context.sent;
                _context.next = 15;
                return service.getCharacteristic(CHARACTERISTIC_UUID);

              case 15:
                characteristic = _context.sent;
                _context.next = 18;
                return characteristic.startNotifications();

              case 18:
                _context.next = 20;
                return characteristic.readValue();

              case 20:
                initialValue = _context.sent;
                characteristic.addEventListener('characteristicvaluechanged', this.onCharacteristicValueChanged);

              case 22:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function connect() {
        return _connect.apply(this, arguments);
      };
    }()
  }, {
    key: "onCharacteristicValueChanged",
    value: function onCharacteristicValueChanged(event) {
      var move = event.target.value.getUint8(16);
      var faceIndex = move >> 4;
      var turnIndex = move & 15;
      var face = faces[faceIndex - 1];
      var amount = turns[turnIndex - 1];
      var notation = '';

      if (amount === 1) {
        notation = face;
      } else if (amount === 2) {
        notation = "".concat(face, "2");
      } else {
        (0, _assert.default)(amount === -1);
        notation = "".concat(face, "'");
      }

      this.emit('move', {
        face: face,
        amount: amount,
        notation: notation
      });
    }
  }]);

  return Giiker;
}(_events.default);

var connect =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2() {
    var giiker;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            giiker = new Giiker();
            _context2.next = 3;
            return giiker.connect();

          case 3:
            return _context2.abrupt("return", giiker);

          case 4:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function connect() {
    return _ref.apply(this, arguments);
  };
}();

var _default = {
  connect: connect
};
exports.default = _default;
